



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>「C语言」int main还是void main？</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">「C语言」int main还是void main？</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 03:51:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>从大一入学刚接触C到现在已满7个月了，虽然刚开始就知道```int main```才是标准的写法，但一直没有深刻理解为什么不能用```void main```而必须使用```int main```。</p>
<p>刚好最近有非计算机相关专业学C的同学问我```int main```、```main```和```void``` ```main```有什么区别，便觉得是时候好好整理一番了，于是有了此博客。</p>
<p><strong>先简而言之</strong><br />1.void 和 int 表明声明不同的主函数返回值，不声明则默认返回值为int整型。<br />2.int main可移植性强。<br />3.C语言从来没声明过```void main```，只声明过```main()```。<br />3.抛弃一切用```void main```编写C程序的习惯！</p>
<p><strong>稍微深入</strong></p>
<p>main函数,又称主函数，作为绝大大部分C程序唯一的入口（比如windows编程中可以编写一个其他windows程序都可以使用的动态链接库（dll）模块，由于DLL模块不是独立的程序，因此不需要main函数。再比如，用于专业环境的程序-----如机器人中的控制芯片--可能不需要main函数），是要求有返回值的，该返回值返回给操作系统来表明改程序的执行状况。返回0代表程序正常执行成功，返回非0值代表程序异常结束，因此返回值需要是int整型，于是有了```int main()```的规范。如果使用```void main```，既声明主函数没有返回值的话，程序随能编译、运行成功，却不利于操作系统判断其状态，这对于由很多C程序构成的大型项目来说是可能会是致命的。</p>
<p>尤其从c99标准（1999年制定的官方C语言标准第二版）开始必须使用```int main```，如果没加```return 0;```语句C99要求编译器自动添加（自己写上是个好习惯）。只声明```main```的话系统默认为```int main```。```void main```无论何时都不应该使用因为主函数必须有返回值表明程序运行状态（在很少的代码中最少不使用```void main```是一个良好的变成习惯）。</p>
<p>学校老版教材推荐编写C程序时使用的 VC6.0 是98年的产品，而C99标准见名思义在1999年制定，因此VC 不会自动添加```return 0;```。Windows下建议尝试使用DEV C++或Visual Studio的IDE环境（集成开发环境）写C代码。</p>
<p><strong>再深入一点</strong></p>
<p>在最新的 C99 标准中，只有以下两种定义方式是正确的：</p>
<div>
<pre class="prettyprint linenums">int main(void){}//整数类型主函数(无类型)<br />
int main(int　argc,char **argv)//整数类型主函数(整数类型　统计参数个数,字符类型*数组指针至字符[])</pre>
</div>
<p>如果没有int main并且不是return 0;的话，编译完C程序后生成了exe文件，在DOS（按下Windows键+r键后输入cmd打开)下用执行该文件的命令时（比如是1.exe），语句后面加上 &amp;&amp; dir 就会发现并没有列出当前目录的列表！（&amp;&amp; 是按先后顺序执行两条命令的连接符，dir命令在DOS下用来列出当前所在文件下的目录列表的～）</p>
<p>为什么没执行成功dir命令呢？正是因为写的C程序没有返回值，操作系统认为程序没有成功执行完毕，因此就不会执行 &amp;&amp; 后面的dir命令了&hellip;</p>
<p>上面两种正确的定义方式一般接触C语言阶段用前者足以，括号里面的void指明主函数并不需要参数，而后者：</p>
<div>
<pre class="prettyprint linenums">int main(int argc, char *argv[]);</pre>
</div>
<p>表明main函数返回值为整型，带两个参数，argc为命令行参数的个数，argv为指针数组，前argc个指针为参数列表，最后一个指针值为NULL。具体见下方链接。</p>
<p><strong>参考链接和可深入理解C的其它链接：</strong><br />main函数_百度百科：<a href="http://baike.baidu.com/link?url=QPL_sSuIxACVYcdTzY43iXtxLGWUPY8inpjL2hZZPFscJZehGeHPUlqf_qG2xPtKKY-tlZPrm78Rsw3TwM-D7a#4_3" rel="external nofollow noreferrer">http://baike.baidu.com/link?url=QPL_sSuIxACVYcdTzY43iXtxLGWUPY8inpjL2hZZPFscJZehGeHPUlqf_qG2xPtKKY-tlZPrm78Rsw3TwM-D7a#4_3</a><br />C99_百度百科：<a href="http://baike.baidu.com/link?url=wGdu4AOAT462i_loNUmdUSqMYXoE-Dur0qQSuHRkXbdy-ib-wMnLp7rrJIwhh_tkf1fICH4JcUkMZ_4n_yIOy_" rel="external nofollow noreferrer">http://baike.baidu.com/link?url=wGdu4AOAT462i_loNUmdUSqMYXoE-Dur0qQSuHRkXbdy-ib-wMnLp7rrJIwhh_tkf1fICH4JcUkMZ_4n_yIOy_</a><br />void main（）还是int main（）_百度贴吧：<a href="http://tieba.baidu.com/p/2085028518" rel="external nofollow noreferrer">http://tieba.baidu.com/p/2085028518</a><br />int main(int argc,char* argv[])详解：<a href="http://www.cnblogs.com/avril/archive/2010/03/22/1691477.html" rel="external nofollow noreferrer">http://www.cnblogs.com/avril/archive/2010/03/22/1691477.html</a><br />C语言启动代码：<a href="http://blog.sina.com.cn/s/blog_53c1950a01011vch.html" rel="external nofollow noreferrer">http://blog.sina.com.cn/s/blog_53c1950a01011vch.html</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4n3y09.html">vim 编辑器使用积累&lpar;for win&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rm4p78.html">【POJ 2318】TOYS 叉积</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rppe78.html">链表 UVA 11988 Broken Keyboard &lpar;a&period;k&period;a&period; Beiju Text&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvxw0o8.html">Java反编译利器-Jad&comma; Jode&comma; Java Decompiler等及其IDE插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o3jpv9.html">跟我学 NHibernate （二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvd7xoq.html">Qt 显示图片 放大 缩小 移动（都是QT直接提供的功能）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y2zw0q.html">DES加密与解密在GET请求时解密失败的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z63149.html">jvm-初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pp0r38.html">Android调试优化篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo45onq.html">利用jenkins做项目的自动化部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yen2g8.html">leetcode &mdash; single-number-ii</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjo6y59.html">js按照特定的中文字进行排序的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdzmwd9.html">JavaScript笔记基础版</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r534zrq.html">webserver apache 2&period;2&period;22-7&sol; apache webdav &sol; redhat 6&period;3</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m24yeoq.html">2018中国大学生程序设计竞赛 - 网络选拔赛 Dream  hdu6440 Dream 给出一个（流氓）构造法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m233x2q.html">Ajax   cookie   session    form组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1reg158.html">D3&period;js的基础部分之数组的处理 数组的排序和求值&lpar;v3版本&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk1z3d8.html">Axios 是一个基于 promise 的 HTTP 库</a>
		</li>
						<li><a href="https://www.batexi.com/a/902p6x4q.html">PAT 1059 C语言竞赛（20）（代码&plus;思路）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppgnnz9.html">css3新增功能</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r93z4ewq.html">VC6&period;0 error LNK2001&colon; unresolved external symbol &lowbar;main解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qykkw29.html">十四、EnterpriseFrameWork框架核心类库之简易ORM</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zww3n8.html">Go加密解密之RSA&lbrack;转&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/495o2768.html">oracle&sol;sqlserver 递归</a>
			</li>
						<li><a href="https://www.batexi.com/a/495o45z8.html">MyBatis自定义数据映射TypeHandler</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql4ym69.html">codeforce No to Palindromes&excl;（枚举）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8oex4l9.html">【转载】SHELL字符串处理技巧（&dollar;&lbrace;&rcub;、&num;&num;、&percnt;&percnt;）</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq11mm4q.html">nodejs 常用全局包</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z0gm1q.html">C&num;语法糖之Cookies操作类 asp&period;net</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyzd2d9.html">谈Mysql索引</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
